<?php
require_once ALI_APPLICATION_PATH . '/models/AbstractModel.php';

class Ali_Model_Options extends Ali_Model_AbstractModel
{
    const PREFIX = Ali_WpPlugin::PREFIX;
    protected $_cache = array();

    public function getValue($name, $default=NULL)
    {
        if (is_null($default)) {
            $config = Ali_Application::getConfig()->default->option;
            if (isset($config->$name)) {
                $default = $config->$name;
                if ($default instanceof AliZend_Config) {
                    $default = $default->toArray();
                }
            }
        }

        return get_option(self::PREFIX . '_' . $name, $default);
    }

    public function setValue($name, $value)
    {
        return update_option(self::PREFIX . '_' . $name, $value);
    }

    public function unsetValue($name)
    {
        return delete_option(self::PREFIX . '_' . $name);
    }
}
